
/*==========================================================================================*/
/*																							*/
/*	Plugin  : Flower_Main																	*/
/*	Version : 2.5																			*/
/*	Author  : Micapat																		*/
/*																							*/
/*	Thanks to ConnorMcLeod for the explosion												*/
/*	--> http://forums.alliedmods.net/showthread.php?t=97012									*/
/*																							*/
/*	Thanks to Hlstriker for the Shoop da whoop												*/
/*	--> http://forums.alliedmods.net/showthread.php?p=907087								*/
/*																							*/
/*==========================================================================================*/

#include < amxmodx >
#include < cstrike >
#include < fun >
#include < fakemeta >
#include < hamsandwich >
#include < engine >

#define GIB_ALWAYS							2
#define is_player(%1)						( 1 <= %1 <= g_MaxPlayers )
#define message_begin_f(%1,%2,%3,%4)		engfunc( EngFunc_MessageBegin, %1, %2, %3, %4 )
#define write_coord_f(%1)					engfunc( EngFunc_WriteCoord, %1 )

#define TASK_EXPLODE						1000
#define TASK_SCREENFADE						2000
#define TASK_CTS_MSG						3000
#define TASK_TS_MSG							4000
#define TASK_SHOOP							5000

enum _: FlowersCvars
{
	CVAR_FW_TIMECANTATTACK = 0,
	CVAR_FW_DAMAGEEXPLOSION,
	CVAR_FW_RADIUSEXPLOSION,
	CVAR_FW_SPEEDEXPLOSION,
	CVAR_FW_GRAVITYEXPLOSION,
	CVAR_FW_MONEYEXPLOSION,
	CVAR_FW_FRAGSEXPLOSION,
	CVAR_FW_CANBUYSHOOP,
	CVAR_FW_PRICESHOOP,
	CVAR_FW_SPEEDSHOOP,
	CVAR_FW_GRAVITYSHOOP,
	CVAR_GD_TIMESCREENFADE,
	CVAR_GD_COLORSCREENFADE,
	CVAR_GD_CANBUYKNIFE,
	CVAR_GD_PRICEKNIFE,
	CVAR_GD_CANBUYAMMOS,
	CVAR_GD_PRICEAMMOS,
	CVAR_MAX
}

new const FLOWERS_TAG[ ]					= "[ Flowers ]";

new const FLOWER_MOTD[ ]					= "flowerHelp.txt";
new const GARDENER_MOTD[ ]					= "gardenerHelp.txt";

new const SOUND_EXPL[ ] 	 				= "flower/yalala.wav";
new const SOUND_PROV[ ]  	 				= "flower/provocation.wav";
new const SOUND_SHOOP_BEGIN[ ]				= "flower/iamfiringmahlaser.wav";
new const SOUND_SHOOP_LAZER[ ]				= "flower/blahhhhh.wav";
new const FLOWER_MODEL[ ]					= "models/player/lag_plat_/lag_plat_.mdl";

new CsTeams:g_PlayerTeam[ 33 ];
new bool:g_bAlive[ 33 ];
new bool:g_bIsANewPlayer[ 33 ];
new bool:g_bGoToExplode[ 33 ];
new bool:g_bHasShoopDaWhoop[ 33 ];
new bool:g_bActivatedShoopDaWhoop[ 33 ];

new g_pCvars[ CVAR_MAX ];

new g_Gibbed[ 33 ];
new g_MaxPlayers;
new g_ExploSprite;
new g_LastTime[ 33 ];
new g_Beam;
new g_RoundTime;

new g_DeathMsg, g_ScreenfadeMsg;

/*==========================================================================================*/

public plugin_init( )
{
	register_plugin( "Flower_Main", "2.5", "Micapat" );
	register_dictionary( "Flower_Main.txt" );
	
	register_touch( "weaponbox", "player", "WeaponsBlock" );
	register_touch( "armoury_entity", "player", "WeaponsBlock" );
	
	RegisterHam( Ham_Spawn, "player", "PlayerSpawn", 1 );
	RegisterHam( Ham_Killed, "player", "PlayerKilled" );
	
	register_clcmd( "say /cut", "CutCmd" );
	register_clcmd( "say_team /cut", "CutCmd" );
	register_clcmd( "say /ammo", "AmmoCmd" );
	register_clcmd( "say_team /ammo", "AmmoCmd" );
	register_clcmd( "say /shoop", "ShoopCmd" );
	register_clcmd( "say_team /shoop", "ShoopCmd" );
	register_clcmd( "say /help", "HelpCmd" );
	
	register_forward( FM_CmdStart, "CmdStart" );
	register_event( "HLTV", "Event_HLTV_New_Round", "a", "1=0", "2=0" );
	register_message( get_user_msgid("ClCorpse"), "Message_ClCorpse" );
	
	g_pCvars[ CVAR_FW_TIMECANTATTACK ] = 	register_cvar( "Fw_TimeCantAttack", "15" );
	g_pCvars[ CVAR_FW_DAMAGEEXPLOSION ] = 	register_cvar( "Fw_DamageExplosion", "60000.0" );
	g_pCvars[ CVAR_FW_RADIUSEXPLOSION ] = 	register_cvar( "Fw_RadiusExplosion", "250" );
	g_pCvars[ CVAR_FW_SPEEDEXPLOSION ] = 	register_cvar( "Fw_SpeedExplosion", "480.0" );
	g_pCvars[ CVAR_FW_GRAVITYEXPLOSION ] =	register_cvar( "Fw_GravityExplosion", "0.75" );
	g_pCvars[ CVAR_FW_MONEYEXPLOSION ] = 	register_cvar( "Fw_MoneyExplosion", "1000" );
	g_pCvars[ CVAR_FW_FRAGSEXPLOSION ] = 	register_cvar( "Fw_FragsExplosion", "2" );
	g_pCvars[ CVAR_FW_CANBUYSHOOP ] = 		register_cvar( "Fw_CanBuyShoop", "1" );
	g_pCvars[ CVAR_FW_PRICESHOOP ] = 		register_cvar( "Fw_PriceShoop", "16000" );
	g_pCvars[ CVAR_FW_SPEEDSHOOP ] = 		register_cvar( "Fw_SpeedShoop", "120.0" );
	g_pCvars[ CVAR_FW_GRAVITYSHOOP ] = 		register_cvar( "Fw_GravityShoop", "2.5" );
	g_pCvars[ CVAR_GD_TIMESCREENFADE ] = 	register_cvar( "Gd_TimeScreenFade", "7" );
	g_pCvars[ CVAR_GD_COLORSCREENFADE ] = 	register_cvar( "Gd_ColorScreenFade", "000000000" );
	g_pCvars[ CVAR_GD_CANBUYKNIFE ] = 		register_cvar( "Gd_CanBuyKnife", "1" );
	g_pCvars[ CVAR_GD_PRICEKNIFE ] = 		register_cvar( "Gd_PriceKnife", "10000" );
	g_pCvars[ CVAR_GD_CANBUYAMMOS ] = 		register_cvar( "Gd_CanBuyAmmos", "1" );
	g_pCvars[ CVAR_GD_PRICEAMMOS ] = 		register_cvar( "Gd_PriceAmmos", "12000" );
	
	g_MaxPlayers = get_maxplayers( );
	g_DeathMsg = get_user_msgid( "DeathMsg" );
	g_ScreenfadeMsg = get_user_msgid( "ScreenFade" );
	
	set_task( 1.0, "CreateRealFlower", 123456789 );
}

public plugin_precache( )
{
	precache_model( "models/rpgrocket.mdl" ); // Necessary for 3D View
	precache_model( FLOWER_MODEL );
	
	g_Beam = 			precache_model( "sprites/xbeam3.spr" );
	g_ExploSprite = 	precache_model( "sprites/zerogxplode.spr" );
	
	precache_sound( SOUND_EXPL );
	precache_sound( SOUND_PROV );
	precache_sound( SOUND_SHOOP_BEGIN );
	precache_sound( SOUND_SHOOP_LAZER );
}

public plugin_cfg( )
{
	set_cvar_string( "mp_freezetime", "0" );
	set_cvar_string( "mp_playerid", "2" );
	set_cvar_num( "sv_maxspeed", 999 );
}

public CreateRealFlower( )
{
	new entity = -1, Float: origin[ 3 ], Float: angles[ 3 ] = { 0.0, 0.0, 0.0 } ;
	
	while(( entity = engfunc( EngFunc_FindEntityByString, entity, "classname", "info_target" )) > 0 )
	{
		engfunc( EngFunc_SetModel, entity, FLOWER_MODEL );
		set_pev( entity, pev_solid, SOLID_NOT );
		set_pev( entity, pev_takedamage, 0.0 );
		
		pev( entity, pev_origin, origin );
		origin[ 2 ] += 28.0;
		engfunc( EngFunc_SetOrigin, entity, origin );
		
		angles[ 1 ] = random_float( 0.0, 360.0 );
		
		set_pev( entity, pev_angles, angles );
	}
	
	set_cvar_num( "sv_restart", 1 );
}

/*==========================================================================================*/

public client_connect( id )
{
	g_bIsANewPlayer[ id ] = true;
	g_bGoToExplode[ id ] = false;
	g_bHasShoopDaWhoop[ id ] = false;
	g_bActivatedShoopDaWhoop[ id ] = false;
	g_bAlive[ id ] = false;
}

public client_disconnect( id )
{
	remove_task( id + TASK_EXPLODE );
	remove_task( id + TASK_SCREENFADE );
	remove_task( id + TASK_CTS_MSG );
	remove_task( id + TASK_TS_MSG );
	remove_task( id + TASK_SHOOP );
	
	g_bIsANewPlayer[ id ] = true;
	g_bGoToExplode[ id ] = false;
	g_bHasShoopDaWhoop[ id ] = false;
	g_bActivatedShoopDaWhoop[ id ] = false;
	g_bAlive[ id ] = false;
}

public client_PreThink( id )
{
	if( !g_bActivatedShoopDaWhoop[ id ] || g_PlayerTeam[ id ] == CS_TEAM_CT || !g_bAlive[ id ] )
	{
		return;
	}
	
	new origin[ 3 ], aiming[ 3 ], id_target, body;
	
	get_user_origin( id, origin );
	get_user_origin( id, aiming, 3 );
	
	ShoopsBeam( origin, aiming );
	
	get_user_aiming( id, id_target, body, 9999 );
	
	if( is_player( id_target ) && g_PlayerTeam[ id_target ] == CS_TEAM_CT && g_bAlive[ id_target ] )
	{
		ExecuteHamB( Ham_TakeDamage, id_target, id, id, 200.0, DMG_BLAST | DMG_ALWAYSGIB );
		
		if( !g_bAlive[ id_target ] ) 
		{
			cs_set_user_deaths( id_target, get_user_deaths( id_target ) + 1 );
			set_user_frags(id, get_user_frags(id) + 2);
			
			message_begin( MSG_ALL, g_DeathMsg );
			write_byte( id );
			write_byte( id_target );
			write_byte( 0 );
			write_string( "" );
			message_end( );
		}
	}
}

/*==========================================================================================*/

public PlayerSpawn( id )
{
	if( is_user_alive( id ))
	{
		if( g_bIsANewPlayer[ id ] )
		{
			g_bIsANewPlayer[ id ] = false;
			
			client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "HELP_COMMAND" );
			
			if( !is_user_bot( id ))
				query_client_cvar( id, "cl_minmodels", "cvar_result" );
		}
		else
		{
			emit_sound( id, CHAN_STATIC, SOUND_EXPL, 1.0, ATTN_NORM, SND_STOP, PITCH_NORM );
			emit_sound( id, CHAN_STATIC, SOUND_SHOOP_BEGIN, 1.0, ATTN_NORM, SND_STOP, PITCH_NORM );
			emit_sound( id, CHAN_STATIC, SOUND_SHOOP_LAZER, 1.0, ATTN_NORM, SND_STOP, PITCH_NORM );
			
			remove_task( id + TASK_EXPLODE );
			remove_task( id + TASK_SCREENFADE );
			remove_task( id + TASK_CTS_MSG );
			remove_task( id + TASK_TS_MSG );
			remove_task( id + TASK_SHOOP );
		
			g_bGoToExplode[ id ] = false;
			g_bHasShoopDaWhoop[ id ] = false;
			g_bActivatedShoopDaWhoop[ id ] = false;
		}
		
		strip_user_weapons( id );
		g_PlayerTeam[ id ] = cs_get_user_team( id );
		g_bAlive[ id ] = true;
		
		switch( g_PlayerTeam[ id ] )
		{
			case CS_TEAM_T:
			{
				set_view( id, CAMERA_3RDPERSON );
				set_user_footsteps( id, 1 );
				set_user_health( id, 1 );
			}
			case CS_TEAM_CT:
			{
				set_view( id, CAMERA_NONE );
				set_user_footsteps( id, 0 );
				
				set_task( 0.25, "ScreenFade", id + TASK_SCREENFADE );
			}
		}
		
		set_task( float( get_pcvar_num( g_pCvars[ CVAR_GD_TIMESCREENFADE ] )), "CtsBeginning", id + TASK_CTS_MSG );
		set_task( float( get_pcvar_num( g_pCvars[ CVAR_FW_TIMECANTATTACK ] )), "TsBeginning", id + TASK_TS_MSG );
		
		g_LastTime[ id ] = get_timeleft( );
	}
	
	return PLUGIN_CONTINUE;
}

public ScreenFade( id )
{
	id -= TASK_SCREENFADE;
	
	if( !g_bAlive[ id ] )
		return;
	
	new iTimeScreenfade = get_pcvar_num( g_pCvars[ CVAR_GD_TIMESCREENFADE ] ) * 4096;
	new iColorScreenfade = get_pcvar_num( g_pCvars[ CVAR_GD_COLORSCREENFADE ] );
	
	if( iTimeScreenfade < 0 )
		iTimeScreenfade = 0;
	else if( iTimeScreenfade > 0xFFFF )
		iTimeScreenfade = 0xFFFF;
	
	message_begin( MSG_ONE_UNRELIABLE, g_ScreenfadeMsg, { 0, 0, 0 }, id );
	write_short( iTimeScreenfade );
	write_short( iTimeScreenfade );
	write_short( 4096 );
	write_byte( ( iColorScreenfade / 1000000 ) );
	write_byte( ( iColorScreenfade / 1000 ) % 1000 );
	write_byte( iColorScreenfade % 1000 );
	write_byte( 255 );
	message_end( );
}

public CtsBeginning( id )
{
	id -= TASK_CTS_MSG;

	if( !g_bAlive[ id ] )
		return;

	switch( g_PlayerTeam[ id ] )
	{
		case CS_TEAM_T:
		{
			set_hudmessage ( 255, 0, 0, -1.0, 0.35, 0, 0.1, 2.5, 0.1, 1.0, -1 );
			show_hudmessage ( id , "%L", id, "HUD_SPOTTED" );
		}
		case CS_TEAM_CT:
		{
			set_hudmessage ( 0, 255, 0, -1.0, 0.40, 0, 0.1, 2.5, 0.1, 1.0, -1 );
			show_hudmessage ( id , "%L", id, "HUD_GARDEN" );
			give_item( id, "weapon_usp" );
		}
	}
}

public TsBeginning( id )
{
	id -= TASK_TS_MSG;

	if( !g_bAlive[ id ] )
		return;
	
	switch( g_PlayerTeam[ id ] )
	{
		case CS_TEAM_T:
		{
			set_hudmessage ( 0, 255, 0, -1.0, 0.35, 0, 0.1, 2.5, 0.1, 1.0, -1 );
			show_hudmessage ( id , "%L", id, "HUD_ANGRY" );
		}
		case CS_TEAM_CT:
		{
			set_hudmessage ( 255, 0, 0, -1.0, 0.40, 0, 0.1, 2.5, 0.1, 1.0, -1 );
			show_hudmessage ( id , "%L", id, "HUD_AGRESSIVE" );
		}
	}
}

public PlayerKilled( id, id_killer, gib )
{
	g_bAlive[ id ] = false;

	if( gib == GIB_ALWAYS )
	{
		g_Gibbed[ id ] = true;
	}	
	
	if( g_bHasShoopDaWhoop[ id ] )
	{
		g_bHasShoopDaWhoop[ id ] = false;
		
		set_hudmessage ( 255, 0, 0, -1.0, 0.35, 0, 0.1, 2.5, 0.1, 1.0, -1 );
		show_hudmessage ( id , "%L", id, "HUD_MADNESS" );
		
		remove_task( id + TASK_EXPLODE );
		
		Explode( id + TASK_EXPLODE );
		
		emit_sound( id, CHAN_STATIC, SOUND_SHOOP_BEGIN, 1.0, ATTN_NORM, SND_STOP, PITCH_NORM );
		emit_sound( id, CHAN_STATIC, SOUND_SHOOP_LAZER, 1.0, ATTN_NORM, SND_STOP, PITCH_NORM );
	}
}

/*==========================================================================================*/

public Event_HLTV_New_Round( )
{
	g_RoundTime = get_timeleft( );
	
	arrayset( g_Gibbed, 0, sizeof( g_Gibbed ) );
}

public Message_ClCorpse( iMsgId, iMsgDest, iMsgEnt )
{
	if( g_Gibbed[ get_msg_arg_int( 12 ) ] )
	{
		return PLUGIN_HANDLED;
	}
	
	return PLUGIN_CONTINUE;
}

public WeaponsBlock( iEnt, id )
{
	if( g_PlayerTeam[ id ] == CS_TEAM_CT )
	{
		return PLUGIN_CONTINUE;
	}
	
	return PLUGIN_HANDLED;
}

/*==========================================================================================*/

public CmdStart(id, cmd)
{
	if( g_bAlive[ id ] && g_PlayerTeam[ id ] == CS_TEAM_T && !g_bGoToExplode[ id ] )
	{
		if( get_uc( cmd, UC_Buttons ) & IN_ATTACK2 && !( entity_get_int( id, EV_INT_oldbuttons ) & IN_ATTACK2 ))
		{
			if ( g_RoundTime - get_timeleft( ) > get_pcvar_num( g_pCvars[ CVAR_FW_TIMECANTATTACK ] ))
			{
				g_bGoToExplode[ id ] = true;
				
				if( !g_bHasShoopDaWhoop[ id ] ) /* Explode */
				{
					set_user_maxspeed( id, get_pcvar_float( g_pCvars[ CVAR_FW_SPEEDEXPLOSION ] ) );
					set_user_gravity( id, get_pcvar_float( g_pCvars[ CVAR_FW_GRAVITYEXPLOSION ] ) );
					
					emit_sound( id, CHAN_STATIC, SOUND_EXPL, 0.5, ATTN_NORM, 0, PITCH_NORM );
					
					client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "LAUNCH_EXPLODE" );
					client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "LAUNCH_EXPLODE_2" );
					
					set_task ( 3.0, "Explode", id + TASK_EXPLODE );
				}
				else /* Shoop Da Whoop  0_0 */
				{
					emit_sound( id, CHAN_STATIC, SOUND_SHOOP_BEGIN, 1.0, ATTN_NORM, 0, PITCH_NORM );
					
					client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "LAUNCH_SHOOP" );
					
					set_hudmessage ( 12, 109, 190, -1.0, 0.45, 0, 0.1, 2.0, 0.1, 1.0, -1 );
					show_hudmessage ( 0 , "WTFFFFFFFFFFFFFFFFFF ???" );
					
					set_task ( 2.5,  "ShoopdaWhoop", id + TASK_SHOOP );
					set_task ( 12.5, "Explode", id + TASK_EXPLODE );
				}
			}
			else
			{
				client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "CANT_LAUNCH" );
			}
		}
		else if( get_uc( cmd, UC_Buttons ) & IN_ATTACK && !( entity_get_int( id, EV_INT_oldbuttons ) & IN_ATTACK ) && ( g_LastTime[ id ] - get_timeleft( ) > 2 ) )
		{
			g_LastTime[ id ] = get_timeleft( );
			emit_sound( id, CHAN_STATIC, SOUND_PROV, 0.5, ATTN_NORM, 0, PITCH_NORM );
		}
	}
}

/*==========================================================================================*/

public cvar_result( id, const cvar[ ], const value[ ] )
{
	if( is_user_connected( id ))
    {
		if( equali( cvar, "cl_minmodels" ))
		{
			if( !strcheck( value ))
			{
				static name[ 32 ];
				get_user_name( id, name, charsmax( name ) );
				
				server_cmd( "kick #%d ^"%s^"", get_user_userid( id ), "cl_minmodels different of 0 !" );
				client_print( 0, print_chat, "%s %L", FLOWERS_TAG, 0, "KICK_MINMODELS", name );
			}
			
			query_client_cvar( id, "cl_minmodels", "cvar_result" );
		}
	}
}

strcheck( const string[ ] )
{
	static i; i = 0;
	
	while( string[ i ] )
	{
		if( string[ i++ ] != '0' )
			return 0;
	}
	
	return 1;
}

/*==========================================================================================*/

public Explode( id )
{
	id -= TASK_EXPLODE;
	
	if( !is_user_connected( id ))
        return;
	
	g_bHasShoopDaWhoop[ id ] = false;
	
	new id_target = -1, Float: origin[ 3 ], Float: realDamage;
	entity_get_vector( id, EV_VEC_origin, origin );
	
	new Float: damage = get_pcvar_float( g_pCvars[ CVAR_FW_DAMAGEEXPLOSION ] );
	new Float: radius = get_pcvar_float( g_pCvars[ CVAR_FW_RADIUSEXPLOSION ] );
	
	// Explosion
	message_begin_f( MSG_BROADCAST, SVC_TEMPENTITY, origin, 0 );
	write_byte( TE_EXPLOSION );
	write_coord_f( origin[ 0 ] );
	write_coord_f( origin[ 1 ] );
	write_coord_f( origin[ 2 ] );
	write_short( g_ExploSprite );
	write_byte( clamp( floatround( radius ), 0, 255 ));
	write_byte( 15 );
	write_byte( 0 );
	message_end( );
	
	new moneyGain = get_pcvar_num( g_pCvars[ CVAR_FW_MONEYEXPLOSION ] );
	new fragsGain = get_pcvar_num( g_pCvars[ CVAR_FW_FRAGSEXPLOSION ] );
	
	new money = cs_get_user_money( id );
	new frags = get_user_frags( id );
	
	while( is_player(( id_target = find_ent_in_sphere( id_target, origin, radius ))))
	{
		if(( realDamage = damage / entity_range( id, id_target )) > 1.0 )
		{
			if(( g_PlayerTeam[ id_target ] == CS_TEAM_CT ) && ( g_bAlive[ id_target ] ))
			{
				ExecuteHamB( Ham_TakeDamage, id_target, id, id, realDamage, DMG_BLAST|DMG_ALWAYSGIB );
				
				if( !g_bAlive[ id_target ] )
				{
					cs_set_user_deaths( id_target, get_user_deaths( id_target ) + 1 );
					money = ( money + moneyGain > 16000 ) ? 16000 : money + moneyGain;
					frags += fragsGain;
					
					message_begin( MSG_ALL, g_DeathMsg );
					write_byte( id );
					write_byte( id_target );
					write_byte( 0 );
					write_string( "" );
					message_end( );
				}
			}
		}
	}
	
	cs_set_user_money( id, money );
	set_user_frags( id, frags + 1 );
	cs_set_user_deaths( id, get_user_deaths( id ) - 1 );
	
	ExecuteHamB( Ham_Killed, id, id, GIB_ALWAYS );
}

/*==========================================================================================*/

public ShoopdaWhoop( id )
{
	id -= TASK_SHOOP;
	
	if( !g_bAlive[ id ] )
		return;
	
	set_user_maxspeed( id, get_pcvar_float( g_pCvars[ CVAR_FW_SPEEDSHOOP ] ) );
	set_user_gravity( id, get_pcvar_float( g_pCvars[ CVAR_FW_GRAVITYSHOOP ] ) );
	g_bActivatedShoopDaWhoop[ id ] = true;
	
	client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "LAUNCH_SHOOP_2" );
	
	emit_sound( id, CHAN_STATIC, SOUND_SHOOP_LAZER, 1.0, ATTN_NORM, 0, PITCH_NORM );
}

ShoopsBeam( StartOrigin[ 3 ], EndOrigin[ 3 ] )
{
	message_begin(MSG_PVS, SVC_TEMPENTITY, StartOrigin);
	
	write_byte( TE_BEAMPOINTS )
	write_coord( StartOrigin[ 0 ] );
	write_coord( StartOrigin[ 1 ] );
	write_coord( StartOrigin[ 2 ] );
	write_coord( EndOrigin[ 0 ] );
	write_coord( EndOrigin[ 1 ] );
	write_coord( EndOrigin[ 2 ] );
	write_short( g_Beam );
	write_byte( 1 );
	write_byte( 1 );
	write_byte( 1 );
	write_byte( 210 );
	write_byte( 1 );
	write_byte( 12 );
	write_byte( 109 );
	write_byte( 190 );
	write_byte( 255 );
	write_byte( 50 );
	
	message_end( );
}

/*==========================================================================================*/

public CutCmd( id )
{
	if( g_PlayerTeam[ id ] != CS_TEAM_CT || !g_bAlive[ id ] || !get_pcvar_num( g_pCvars[ CVAR_GD_CANBUYKNIFE ] ) )
	{
		return;
	}
	
	new iMoney = cs_get_user_money( id );
	new iCost = get_pcvar_num( g_pCvars[ CVAR_GD_PRICEKNIFE ] );
	
	if( iMoney < iCost )
	{
		client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "CANT_BUY_CUT", iCost - iMoney );
		return;
	}
	
	give_item( id, "weapon_knife" );
	cs_set_user_money( id, iMoney - iCost );
	
	client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "BUY_CUT" );
}

public AmmoCmd( id )
{
	if( g_PlayerTeam[ id ] != CS_TEAM_CT || !g_bAlive[ id ] || !get_pcvar_num( g_pCvars[ CVAR_GD_CANBUYAMMOS ] ) )
	{
		return;
	}
	
	new iMoney = cs_get_user_money( id );
	new iCost = get_pcvar_num( g_pCvars[ CVAR_GD_PRICEAMMOS ] );
	
	if( iMoney < iCost )
	{
		client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "CANT_BUY_AMMOS", iCost - iMoney );
		return;
	}
	
	cs_set_user_money( id, iMoney - iCost );
	cs_set_user_bpammo( id, CSW_USP, cs_get_user_bpammo( id, CSW_USP ) + 12 );
	client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "BUY_AMMOS" );
}

public ShoopCmd( id )
{
	if( g_PlayerTeam[ id ] != CS_TEAM_T || !g_bAlive[ id ] || !get_pcvar_num( g_pCvars[ CVAR_FW_CANBUYSHOOP ] ))
	{
		return;
	}
	
	new iMoney = cs_get_user_money( id );
	new iCost = get_pcvar_num( g_pCvars[ CVAR_FW_PRICESHOOP ] );
	
	if( iMoney < iCost )
	{
		client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "CANT_BUY_SHOOP", iCost - iMoney );
		return;
	}
	
	cs_set_user_money( id, iMoney - iCost );
	g_bHasShoopDaWhoop[ id ] = true;
	
	client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "BUY_SHOOP" );
	client_print( id, print_chat, "%s %L", FLOWERS_TAG, id, "BUY_SHOOP_2" );
}

public HelpCmd( id )
{
	switch( g_PlayerTeam[ id ] )
	{
		case CS_TEAM_T:  show_motd( id, FLOWER_MOTD );
		case CS_TEAM_CT: show_motd( id, GARDENER_MOTD );
	}
}
